Skip to content
Start here

Create a new Rego module

client.ZeroTrust.CWS.RegoModules.New(ctx, params) (*RegoModule, error)
POST/accounts/{account_id}/cws/rego-modules

Creates a library Rego module and derives its package path from the source.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
ParametersExpand Collapse
params CWSRegoModuleNewParams
AccountID param.Field[string]

Path param: Cloudflare account ID (32-character hexadecimal string)

maxLength32
minLength32
Name param.Field[string]

Body param: Name of the Rego module (unique per account)

maxLength100
minLength1
RegoSource param.Field[string]

Body param: Library Rego source with a package beginning with “lib.” Maximum 16384 UTF-8 bytes.

maxLength16384
minLength1
ReturnsExpand Collapse
type RegoModule struct{…}
ID string

Server-assigned UUID

formatuuid
CreatedAt Time
formatdate-time
Name string

Human-readable name; unique per account

maxLength100
minLength1
PackagePath string

Dotted path derived from rego_source. Begins with lib. and is unique per account.

maxLength1024
RegoSource string

Library Rego source with a package beginning with “lib.” Maximum 16384 UTF-8 bytes.

maxLength16384
minLength1
UpdatedAt Time
formatdate-time

Create a new Rego module

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/zero_trust"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  regoModule, err := client.ZeroTrust.CWS.RegoModules.New(context.TODO(), zero_trust.CWSRegoModuleNewParams{
    AccountID: cloudflare.F("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"),
    Name: cloudflare.F("x"),
    RegoSource: cloudflare.F("x"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", regoModule.ID)
}
{
  "errors": [
    {
      "code": 0,
      "message": "message",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 0,
      "message": "message",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "created_at": "2019-12-27T18:11:19.117Z",
    "name": "x",
    "package_path": "package_path",
    "rego_source": "x",
    "updated_at": "2019-12-27T18:11:19.117Z"
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 0,
      "message": "message",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 0,
      "message": "message",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "created_at": "2019-12-27T18:11:19.117Z",
    "name": "x",
    "package_path": "package_path",
    "rego_source": "x",
    "updated_at": "2019-12-27T18:11:19.117Z"
  },
  "success": true
}